[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.95 and 1.130

version 1.95, 2021/12/21 02:16:47 version 1.130, 2021/12/25 18:22:38
Line 34 
Line 34 
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub  FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
   VERBOSE=false
   DELETE=false
 DOWNLOAD=true  DOWNLOAD=true
 INSTALL=true  INSTALL=true
 LOCALSRC=  LOCALSRC=
   
   unset FTPPID
   unset FWPKGTMP
   REMOVE_LOCALSRC=false
   cleanup() {
           set +o errexit # ignore errors from killing ftp
           [ "${FTPPID:-}" ] && kill -TERM -"$FTPPID" 2>/dev/null
           [ "${FWPKGTMP:-}" ] && rm -rf "$FWPKGTMP"
           "$REMOVE_LOCALSRC" && rm -rf "$LOCALSRC"
   }
   trap cleanup EXIT
   
 tmpdir() {  tmpdir() {
         local _i=1 _dir          local _i=1 _dir
   
Line 55 
Line 68 
 }  }
   
 fetch() {  fetch() {
         local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit _error=''          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit _error=''
   
         # If we're not in the installer,          # If we're not in the installer,
         # we have su(1) and doas(1) is unlikely to be configured.          # we have su(1) and doas(1) is unlikely to be configured.
         set -o monitor # make sure ftp gets its own process group          set -o monitor # make sure ftp gets its own process group
         (          (
           flags=-VM
           "$VERBOSE" && flags=-vm
         if [ -x /usr/bin/su ]; then          if [ -x /usr/bin/su ]; then
                 exec /usr/bin/su -s /bin/ksh "$_user" -c \                  exec /usr/bin/su -s /bin/ksh "$_user" -c \
                     "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"                      "/usr/bin/ftp -N '${0##/}' -D 'Get/Verify' $flags -o- '$_src'" > "$_dst"
         else          else
                 exec /usr/bin/doas -u "$_user" \                  exec /usr/bin/doas -u "$_user" \
                     /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"                      /usr/bin/ftp -N "${0##/}" -D 'Get/Verify' $flags -o- "$_src" > "$_dst"
         fi          fi
         ) & _pid=$!          ) & FTPPID=$!
         set +o monitor          set +o monitor
   
         trap "kill -TERM '-$_pid'; exit 1" EXIT INT QUIT ABRT TERM  
   
         SECONDS=0          SECONDS=0
         _last=0          _last=0
         while kill -0 -"$_pid" 2>/dev/null; do          while kill -0 -"$FTPPID" 2>/dev/null; do
                 if [[ $SECONDS -gt 12 ]]; then                  if [[ $SECONDS -gt 12 ]]; then
                         set -- $( ls -ln "$_dst" 2>/dev/null )                          set -- $( ls -ln "$_dst" 2>/dev/null )
                         if [[ $_last -ne $5 ]]; then                          if [[ $_last -ne $5 ]]; then
Line 83 
Line 96 
                                 SECONDS=0                                  SECONDS=0
                                 sleep 1                                  sleep 1
                         else                          else
                                 kill -INT -"$_pid"                                  kill -INT -"$FTPPID"
                                 _error=" (timed out)"                                  _error=" (timed out)"
                         fi                          fi
                 else                  else
Line 92 
Line 105 
         done          done
   
         set +o errexit          set +o errexit
         wait "$_pid"          wait "$FTPPID"
         _exit=$?          _exit=$?
         set -o errexit          set -o errexit
   
         trap "" EXIT INT QUIT ABRT TERM          unset FTPPID
   
         if [ "$_exit" -ne 0 ]; then          if [ "$_exit" -ne 0 ]; then
                 rm -f "$_dst"                  rm -f "$_dst"
Line 113 
Line 126 
         fi          fi
 }  }
   
 devices_needing_firmware() {  firmware_in_dmesg() {
         local _d _m _line _dmesgtail _last='' _nl=$( echo )          local _d _m _line _dmesgtail _last='' _nl=$( echo )
   
         # When we're not in the installer, the dmesg.boot can          # When we're not in the installer, the dmesg.boot can
Line 148 
Line 161 
 }  }
   
 installed_firmware() {  installed_firmware() {
         set +o noglob          local _pre="$1" _match="$2" _post="$3" _firmware
         for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do          set -sA _firmware -- $(
                 [ -e "$fw" ] || continue              set +o noglob
               grep -Fxl '@option firmware' \
                   "${DESTDIR}/var/db/pkg/"$_pre"$_match"$_post"/+CONTENTS" \
                   2>/dev/null || true
               set -o noglob
           )
   
           [ "${_firmware[*]:-}" ] || return 0
           for fw in "${_firmware[@]}"; do
                   fw="${fw%/+CONTENTS}"
                 echo "${fw##*/}"                  echo "${fw##*/}"
         done          done
         set -o noglob  
 }  }
   
   detect_firmware() {
           local _devices _last='' _d
   
           set -sA _devices -- $(
               firmware_in_dmesg
               for _d in $( installed_firmware '*' '-firmware-' '*' ); do
                   echo "$( firmware_devicename "$_d" )"
               done
           )
   
           [ "${_devices[*]:-}" ] || return 0
           for _d in "${_devices[@]}"; do
                   [[ $_last = $_d ]] && continue
                   echo $_d
                   _last="$_d"
           done
   }
   
 add_firmware () {  add_firmware () {
         local _f="${1##*/}"          local _f="${1##*/}" _pkgname
         local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"          FWPKGTMP="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"
         ftp -D "Install" -Vmo- "file:${1}" |          local flags=-VM
                 tar -s ",^\+,${_pkgdir}/+," \          "$VERBOSE" && flags=-vm
           ftp -N "${0##/}" -D "Install" "$flags" -o- "file:${1}" |
                   tar -s ",^\+,${FWPKGTMP}/+," \
                     -s ",^firmware,${DESTDIR}/etc/firmware," \                      -s ",^firmware,${DESTDIR}/etc/firmware," \
                     -C / -zxphf - "+*" "firmware/*"                      -C / -zxphf - "+*" "firmware/*"
   
           _pkgname="$( sed -n '/^@name /{s///p;q;}' "${FWPKGTMP}/+CONTENTS" )"
           if [ ! "$_pkgname" ]; then
                   echo "Failed to extract name from $1, partial install" 2>&1
                   rm -rf "$FWPKGTMP"
                   unset FWPKGTMP
                   return 1
           fi
   
         # TODO: Should we mark these so real fw_update can -Drepair?          # TODO: Should we mark these so real fw_update can -Drepair?
         ed -s "${_pkgdir}/+CONTENTS" <<EOL          ed -s "${FWPKGTMP}/+CONTENTS" <<EOL
 /^@comment pkgpath/ -1a  /^@comment pkgpath/ -1a
 @option manual-installation  @option manual-installation
 @option firmware  @option firmware
Line 173 
Line 222 
 .  .
 w  w
 EOL  EOL
   
           chmod 755 "$FWPKGTMP"
           mv "$FWPKGTMP" "${DESTDIR}/var/db/pkg/${_pkgname}"
           unset FWPKGTMP
 }  }
   
 delete_firmware() {  delete_firmware() {
         local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
   
         # TODO: Check hash for files before deleting          # TODO: Check hash for files before deleting
         echo "Uninstalling $_pkg"          "$VERBOSE" && echo "Uninstalling $_pkg"
         _cwd="${_pkgdir}/$_pkg"          _cwd="${_pkgdir}/$_pkg"
   
           if [ ! -e "$_cwd/+CONTENTS" ] ||
               ! grep -Fxq '@option firmware' "$_cwd/+CONTENTS"; then
                   echo "${0##*/}: $_pkg does not appear to be firmware" >&2
                   return 2
           fi
   
         set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
   
         while read -r c g; do          while read -r c g; do
Line 211 
Line 270 
 }  }
   
 usage() {  usage() {
         echo "usage:  ${0##*/} [-D | -L] [driver | file ...]"          echo "usage:  ${0##*/} [-d | -D] [-av] [-p path] [driver | file ...]"
         exit 2          exit 2
 }  }
   
   ALL=false
 OPT_D=  OPT_D=
 OPT_L=  while getopts :adDp:v name
 while getopts DL name  
 do  do
        case "$name" in         case "$name" in
          a) ALL=true ;;
          d) DELETE=true ;;
        D) OPT_D=true ;;         D) OPT_D=true ;;
        L) OPT_L=true ;;         p) LOCALSRC="$OPTARG" ;;
        ?) usage 2 ;;         v) VERBOSE=true ;;
          :)
              echo "${0##*/}: option requires an argument -- -$OPTARG" >&2
              usage 2
              ;;
          ?)
              echo "${0##*/}: unknown option -- -$OPTARG" >&2
              usage 2
              ;;
        esac         esac
 done  done
 shift $((OPTIND - 1))  shift $((OPTIND - 1))
   
 [ "$OPT_D" ] && [ "$OPT_L" ] && usage 1  if [ "$LOCALSRC" ]; then
           if [[ $LOCALSRC = @(ftp|http?(s))://* ]]; then
                   FWURL="${LOCALSRC}"
                   LOCALSRC=
           else
                   LOCALSRC="${LOCALSRC:#file:}"
                   ! [ -d "$LOCALSRC" ] &&
                       echo "The path must be a URL or an existing directory" >&2 &&
                       exit 2
           fi
   fi
   
   # "Download only" means local dir and don't install
 if [ "$OPT_D" ]; then  if [ "$OPT_D" ]; then
         # "Download only" means local dir and don't install  
         INSTALL=false          INSTALL=false
         LOCALSRC=.          LOCALSRC="${LOCALSRC:-.}"
 elif [ "$OPT_L" ]; then  elif [ "$LOCALSRC" ]; then
         # "Local" means don't download, install from local dir  
         DOWNLOAD=false          DOWNLOAD=false
         LOCALSRC=.  
 else  
         LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"  
 fi  fi
   
 CFILE="$LOCALSRC/$CFILE"  if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then
   
 if "$INSTALL" && [ -x /usr/bin/id ] && [ $(/usr/bin/id -u) != 0 ]; then  
         echo "need root privileges" >&2          echo "need root privileges" >&2
         exit 1          exit 1
 fi  fi
   
 set -A devices -- "$@"  set -sA devices -- "$@"
   
 if [ ! "${devices[*]:-}" ]; then  if "$DELETE"; then
         echo -n "Detecting firmware ..."          [ "$OPT_D" ] && usage 22
         set -A devices -- $( devices_needing_firmware )  
         [ "${devices[*]:-}" ] && echo " found." || echo " done."          set -A installed
           if [ "${devices[*]:-}" ]; then
                   "$ALL" && usage 22
   
                   set -A installed -- $(
                       for d in "${devices[@]}"; do
                           f="${d##*/}"  # only care about the name
                           f="${f%.tgz}" # allow specifying the package name
                           [ "$( firmware_devicename "$f" )" = "$f" ] && f="$f-firmware"
   
                           set -A i -- $( installed_firmware '' "$f-" '*' )
   
                           if [ "${i[*]:-}" ]; then
                                   echo "${i[@]}"
                           else
                                   echo "No firmware found for '$d'" >&2
                           fi
                       done
                   )
           elif "$ALL"; then
                   set -A installed -- $( installed_firmware '*' '-firmware-' '*' )
           fi
   
           deleted=''
           if [ "${installed:-}" ]; then
                   for fw in "${installed[@]}"; do
                           delete_firmware "$fw" || continue
                           deleted="$deleted,$( firmware_devicename "$fw" )"
                   done
           fi
   
           deleted="${deleted:+${deleted#,}}"
           echo "${0:##*/}: deleted ${deleted:-none}";
   
           exit
 fi  fi
   
   if [ ! "$LOCALSRC" ]; then
       LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
       REMOVE_LOCALSRC=true
   fi
   
   CFILE="$LOCALSRC/$CFILE"
   
   if [ "${devices[*]:-}" ]; then
           "$ALL" && usage 22
   else
           "$VERBOSE" && echo -n "Detecting firmware ..."
           set -sA devices -- $( detect_firmware )
           "$VERBOSE" &&
               { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }
   fi
   
 [ "${devices[*]:-}" ] || exit  [ "${devices[*]:-}" ] || exit
   
 if "$DOWNLOAD"; then  if "$DOWNLOAD"; then
           set +o noclobber # we want to get the latest CFILE
         fetch "$CFILE"          fetch "$CFILE"
           set -o noclobber
         ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
             echo "Signature check of SHA256.sig failed" >&2 && exit 1              echo "Signature check of SHA256.sig failed" >&2 && exit 1
   elif [ ! -e "$CFILE" ]; then
           # TODO: We shouldn't need a CFILE if all arguments are files.
           echo "${0##*/}: $CFILE: No such file or directory" >&2
           exit 2
 fi  fi
   
   added=''
   updated=''
   kept=''
 for f in "${devices[@]}"; do  for f in "${devices[@]}"; do
         d="$( firmware_devicename "$f" )"          d="$( firmware_devicename "$f" )"
   
Line 276 
Line 408 
                 exit 2                  exit 2
         fi          fi
   
         set -A installed -- $( installed_firmware "$d" )          set -A installed -- $( installed_firmware '' "$d-firmware-" '*' )
   
         if "$INSTALL" && [ "${installed[*]:-}" ]; then          if "$INSTALL" && [ "${installed[*]:-}" ]; then
                 for i in "${installed[@]}"; do                  for i in "${installed[@]}"; do
                         if [ "${f##*/}" = "$i.tgz" ]; then                          if [ "${f##*/}" = "$i.tgz" ]; then
                                 echo "$i already installed"                                  "$VERBOSE" && echo "$i already installed"
                                   kept="$kept,$d"
                                 continue 2                                  continue 2
                         fi                          fi
                 done                  done
Line 289 
Line 422 
   
         if [ -e "$f" ]; then          if [ -e "$f" ]; then
                 if "$DOWNLOAD"; then                  if "$DOWNLOAD"; then
                         echo "Verify existing ${f##*/}"                          "$VERBOSE" && echo "Verify existing ${f##*/}"
                         verify "$f" || continue                          verify "$f" || continue
                           "$INSTALL"  || kept="$kept,$d"
                 # else assume it was verified when downloaded                  # else assume it was verified when downloaded
                 fi                  fi
         elif "$DOWNLOAD"; then          elif "$DOWNLOAD"; then
                 fetch  "$f" || continue                  fetch  "$f" || continue
                 verify "$f" || continue                  verify "$f" || continue
                   "$INSTALL"  || added="$added,$d"
         elif "$INSTALL"; then          elif "$INSTALL"; then
                 echo "Cannot install ${f##*/}, not found" >&2                  echo "Cannot install ${f##*/}, not found" >&2
                 continue                  continue
Line 303 
Line 438 
   
         "$INSTALL" || continue          "$INSTALL" || continue
   
           removed=false
         if [ "${installed[*]:-}" ]; then          if [ "${installed[*]:-}" ]; then
                 for i in "${installed[@]}"; do                  for i in "${installed[@]}"; do
                         delete_firmware "$i"                          delete_firmware "$i"
                           removed=true
                 done                  done
         fi          fi
   
         add_firmware "$f"          add_firmware "$f"
   
           if "$removed"; then
                   updated="$updated,$d"
           else
                   added="$added,$d"
           fi
 done  done
   
   added="${added:#,}"
   updated="${updated:#,}"
   kept="${kept:#,}"
   if "$INSTALL"; then
           echo  "${0##*/}: added ${added:-none}; updated ${updated:-none}; kept ${kept:-none}"
   else
           echo  "${0##*/}: downloaded ${added:-none}; kept ${kept:-none}"
   fi

Legend:
Removed from v.1.95  
changed lines
  Added in v.1.130

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>